import timeit
import numpy as np
import c_for_speed.nanofibonacci
import c_for_speed.cysum

def timefunc(stmt, number=100, repeat=1):
    times = timeit.repeat(stmt, repeat=repeat, number=number, globals=globals())
    print(f"{stmt}: {number} loops, best of {repeat}: {min(times)} per loop, {min(times)/number} per statement")

if __name__ == "__main__":
    x = np.random.random(100000)
    num = 100
    timefunc("c_for_speed.cysum.cysum(x)", number=num)
    timefunc("c_for_speed.nanofibonacci.sum(x)", number=num)
    timefunc("c_for_speed.nanofibonacci.vsum(x)", number=num)    
    timefunc("c_for_speed.nanofibonacci.eigensum(x)", number=num)    
    timefunc("np.sum(x)", number=num)
    print("c_for_speed.cysum.cysum(x)", c_for_speed.cysum.cysum(x))
    print("c_for_speed.nanofibonacci.sum(x)", c_for_speed.nanofibonacci.sum(x))
    print("c_for_speed.nanofibonacci.vsum(x)", c_for_speed.nanofibonacci.vsum(x))
    print("c_for_speed.nanofibonacci.eigensum(x)", c_for_speed.nanofibonacci.eigensum(x))
print("np.sum(x)", np.sum(x))
