#include <Python.h>

long long fibonacci(unsigned int n) {
  if (n==0) {
    return 0;
  } else if (n == 1) {
    return 1;
  } else {
    return fibonacci(n - 2) + fibonacci(n - 1);
  }
}

void bug(PyObject *list) {
  PyObject *item = PyList_GetItem(list, 0);
  Py_INCREF(item);
  PyList_SetItem(list, 1, PyLong_FromLong(0L));
  PyObject_Print(item, stdout, 0);
  Py_DECREF(item);
}

static PyObject* fibonacci_py(PyObject* self, PyObject *args) {
  PyObject *result = NULL;
  long n;
  long long fib;

  if(PyArg_ParseTuple(args, "l", &n)) {
    Py_BEGIN_ALLOW_THREADS;
    fib = fibonacci(n);
    Py_END_ALLOW_THREADS;
    
    result = Py_BuildValue("L", fib);
  }

  return result;
}
static char fibonacci_docs[] = "fibonacci(n): Return nth Fibonacci sequence number computed recursively\n";
static PyMethodDef cfibonacci_module_methods[] = {
  {"fibonacci", (PyCFunction)fibonacci_py,
   METH_VARARGS, fibonacci_docs},
  {NULL, NULL, 0, NULL}
};
static struct PyModuleDef cfibonacci_module_definition = {
  PyModuleDef_HEAD_INIT,
  "cfibonacci",
  "Extension module that provides fibonacci sequence function",
  -1,
  cfibonacci_module_methods
};
PyMODINIT_FUNC PyInit_cfibonacci(void) {
  Py_Initialize();
  return PyModule_Create(&cfibonacci_module_definition);
}
