#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define SEC_TO_US(sec) ((sec)*1000000)
#define NS_TO_US(ns) ((ns)/1000)

uint64_t micros() {
  struct timespec ts;
  timespec_get(&ts, TIME_UTC);
  uint64_t us = SEC_TO_US((uint64_t)ts.tv_sec) + NS_TO_US((uint64_t)ts.tv_nsec);
  return us;
}

#define ARRSIZE 100000
#define REPS 100

int main() {
  srand((unsigned int)time(NULL));
  double vals[ARRSIZE];
  for(int i=0;i<ARRSIZE;++i)
    vals[i] = ((double)rand()/(double)(RAND_MAX));

  uint64_t start = micros();
  double val;
  for(int i=0;i<REPS;++i){
    val = 0.0;
    for(int i=0;i<ARRSIZE;++i)
      val += vals[i];
  }
  uint64_t stop = micros();
  printf("%f\n%f us\n", val, (double)(stop-start)/(double)REPS);
}
