#include <nanobind/nanobind.h>
#include <nanobind/ndarray.h>
#include <nanobind/eigen/dense.h>
#include <Eigen/Dense>
namespace nb = nanobind;
double eigensum(const nb::DRef<Eigen::ArrayXd> &a) {
  return a.sum();
}
double sum(const nb::ndarray<double, nb::ndim<1>, nb::c_contig, nb::device::cpu> &a) {
  double ret = 0.0;
#pragma clang loop interleave_count(8)
  for(int i=0;i<a.size();++i)
    ret += a(i);
  return ret;
}
double vsum(const nb::ndarray<double, nb::ndim<1>, nb::c_contig, nb::device::cpu> &a) {
  auto v = a.view();
  double ret = 0.0;
#pragma clang loop interleave(enable)
  for(int i=0;i<v.shape(0);++i)
    ret += v(i);
  return ret;
}
long long fibonacci(unsigned int n) {
  if (n==0) {
    return 0;
  } else if (n == 1) {
    return 1;
  } else {
    return fibonacci(n - 2) + fibonacci(n - 1);
  }
}
NB_MODULE(nanofibonacci, m) {
  m.def("fibonacci", &fibonacci);
  m.def("sum", &sum);
  m.def("vsum", &vsum);
  m.def("eigensum", &eigensum);
}
